diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 20b7e44e6..dc966a962 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -11,7 +11,6 @@ import it.unimi.dsi.fastutil.objects.ObjectOpenHashSet;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.ISupport;
-import net.minecraft.core.block.support.PartialSupport;
 import net.minecraft.core.current.wire.WireHandler;
 import net.minecraft.core.entity.EntityItem;
 import net.minecraft.core.entity.animal.MobFireflyCluster;
@@ -392,19 +391,14 @@ public class World implements MutableWorldSource {
     }
 
     @Override
-    public int getBlockId(final @NotNull TilePosc tilePos) {
+    public @NotNull Block<?> getBlockType(final @NotNull TilePosc tilePos) {
         if (!tilePos.inBounds(this)) {
-            return 0;
+            return Blocks.AIR;
         } else {
-            return this.getChunk(tilePos).getBlockId(new ChunkTilePos(tilePos));
+            return this.getChunk(tilePos).getBlock(new ChunkTilePos(tilePos));
         }
     }
 
-    @Override
-    public @Nullable Block<?> getBlock(final @NotNull TilePosc tilePos) {
-        return Blocks.getBlock(this.getBlockId(tilePos));
-    }
-
     @Override
     public double getBlockTemperature(final @NotNull TilePosc tilePos) {
         if (tilePos.x() < MIN_BLOCK_X || tilePos.z() < MIN_BLOCK_Z || tilePos.x() > MAX_BLOCK_X || tilePos.z() > MAX_BLOCK_Z) {
@@ -530,7 +524,7 @@ public class World implements MutableWorldSource {
     }
 
     public boolean isAirBlock(final @NotNull TilePosc tilePos) {
-        return this.getBlockId(tilePos) == 0;
+        return this.getBlockType(tilePos) == Blocks.AIR;
     }
 
     @Deprecated
@@ -551,6 +545,9 @@ public class World implements MutableWorldSource {
         return this.isBlockLoaded(new TilePos(x, y, z));
     }
 
+    public boolean areBlocksLoaded(final @NotNull AABBdc aabb) {
+        return this.areBlocksLoaded(new TilePos(aabb.minX(), aabb.minY(), aabb.minZ()), new TilePos(aabb.maxX(), aabb.maxY(), aabb.maxZ()));
+    }
     public boolean areBlocksLoaded(final @NotNull TilePosc tilePos, final int range) {
         return this.areBlocksLoaded(tilePos.sub(range, range, range, new TilePos()), tilePos.add(range, range, range, new TilePos()));
     }
@@ -621,53 +618,48 @@ public class World implements MutableWorldSource {
     }
 
     @Override
-    public boolean setBlockIdData(final @NotNull TilePosc tilePos, final int id, final int data) {
+    public boolean setBlockTypeData(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final int data) {
         if (!tilePos.inBounds(this)) {
             return false;
         } else {
-            return this.getChunk(tilePos).setBlockIdData(new ChunkTilePos(tilePos), id, data);
+            return this.getChunk(tilePos).setBlockIdData(new ChunkTilePos(tilePos), block.id(), data);
         }
     }
 
-    public boolean setBlockIdRaw(final @NotNull TilePosc tilePos, final int id) {
-        return this.setBlockIdDataRaw(tilePos, id, this.getBlockData(tilePos));
+    public boolean setBlockTypeRaw(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        return this.setBlockTypeDataRaw(tilePos, block, this.getBlockData(tilePos));
     }
 
     @Deprecated
     public final boolean setBlockRaw(final int x, final int y, final int z, final int id) {
-        return this.setBlockIdRaw(new TilePos(x, y, z), id);
+        return this.setBlockTypeRaw(new TilePos(x, y, z), Objects.requireNonNull(Blocks.getBlock(id)));
     }
 
-    public boolean setBlockIdDataRaw(final @NotNull TilePosc tilePos, final int id, final int data) {
+    public boolean setBlockTypeDataRaw(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final int data) {
         if (!tilePos.inBounds(this)) {
             return false;
         } else {
-            return this.getChunk(tilePos).setBlockIdDataRaw(new ChunkTilePos(tilePos), id, data);
+            return this.getChunk(tilePos).setBlockIdDataRaw(new ChunkTilePos(tilePos), block.id(), data);
         }
     }
 
     @Deprecated
     public final boolean setBlockAndMetadataRaw(final int x, final int y, final int z, final int id, final int metadata) {
-        return this.setBlockIdDataRaw(new TilePos(x, y, z), id, metadata);
+        return this.setBlockTypeDataRaw(new TilePos(x, y, z), Objects.requireNonNull(Blocks.getBlock(id)), metadata);
     }
 
     @Override
-    public boolean setBlockId(final @NotNull TilePosc tilePos, final int id) {
+    public boolean setBlockType(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (!tilePos.inBounds(this)) {
             return false;
         } else {
-            return this.getChunk(tilePos).setBlockId(new ChunkTilePos(tilePos), id);
+            return this.getChunk(tilePos).setBlockId(new ChunkTilePos(tilePos), block.id());
         }
     }
 
     @Override
     public @NotNull Material getBlockMaterial(final @NotNull TilePosc tilePos) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
-        if (block == null) {
-            return Materials.AIR;
-        } else {
-            return block.getMaterial();
-        }
+        return this.getBlockType(tilePos).getMaterial();
     }
 
     @Override
@@ -683,9 +675,9 @@ public class World implements MutableWorldSource {
         if (this.setBlockData(tilePos, data)) {
             this.markBlockNeedsUpdate(tilePos);
 
-            final int id = this.getBlockId(tilePos);
-            if (Blocks.neighborNotifyOnMetadataChangeDisabled[id & 0x3FFF]) {
-                this.notifyBlocksOfNeighborChange(tilePos, id);
+            final @NotNull Block<?> block = this.getBlockType(tilePos);
+            if (block.neighborNotifyOnDataChangeDisabled()) {
+                this.notifyBlocksOfNeighborChange(tilePos, block);
                 return true;
             }
         }
@@ -708,9 +700,9 @@ public class World implements MutableWorldSource {
         }
     }
 
-    public boolean setBlockIdNotify(final @NotNull TilePosc tilePos, final int id) {
-        if (this.setBlockId(tilePos, id)) {
-            this.notifyBlockChange(tilePos, id);
+    public boolean setBlockTypeNotify(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
+        if (this.setBlockType(tilePos, block)) {
+            this.notifyBlockChange(tilePos, block);
             return true;
         }
 
@@ -719,12 +711,12 @@ public class World implements MutableWorldSource {
 
     @Deprecated
     public final boolean setBlockWithNotify(final int x, final int y, final int z, final int id) {
-        return this.setBlockIdNotify(new TilePos(x, y, z), id);
+        return this.setBlockTypeNotify(new TilePos(x, y, z), Objects.requireNonNull(Blocks.getBlock(id)));
     }
 
-    public boolean setBlockIdDataNotify(final @NotNull TilePosc tilePos, final int id, final int data) {
-        if (this.setBlockIdData(tilePos, id, data)) {
-            this.notifyBlockChange(tilePos, id);
+    public boolean setBlockTypeDataNotify(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final int data) {
+        if (this.setBlockTypeData(tilePos, block, data)) {
+            this.notifyBlockChange(tilePos, block);
             return true;
         }
 
@@ -733,7 +725,7 @@ public class World implements MutableWorldSource {
 
     @Deprecated
     public final boolean setBlockAndMetadataWithNotify(final int x, final int y, final int z, final int id, final int data) {
-        return this.setBlockIdDataNotify(new TilePos(x, y, z), id, data);
+        return this.setBlockTypeDataNotify(new TilePos(x, y, z), Objects.requireNonNull(Blocks.getBlock(id)), data);
     }
 
     public void markBlockNeedsUpdate(final @NotNull TilePosc tilePos) {
@@ -747,14 +739,14 @@ public class World implements MutableWorldSource {
         this.markBlockNeedsUpdate(new TilePos(x, y, z));
     }
 
-    public void notifyBlockChange(final @NotNull TilePosc tilePos, final int id) {
+    public void notifyBlockChange(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         this.markBlockNeedsUpdate(tilePos);
-        this.notifyBlocksOfNeighborChange(tilePos, id);
+        this.notifyBlocksOfNeighborChange(tilePos, block);
     }
 
     @Deprecated
     public final void notifyBlockChange(final int x, final int y, final int z, final int id) {
-        this.notifyBlockChange(new TilePos(x, y, z), id);
+        this.notifyBlockChange(new TilePos(x, y, z), Objects.requireNonNull(Blocks.getBlock(id)));
     }
 
     public void markBlocksDirtyVertical(final int x, final int z, final int y0, final int y1) {
@@ -790,29 +782,27 @@ public class World implements MutableWorldSource {
         this.markBlocksDirty(new TilePos(minX, minY, minZ), new TilePos(maxX, maxY, maxZ));
     }
 
-    public void notifyBlocksOfNeighborChange(final @NotNull TilePosc tilePos, final int id) {
+    public void notifyBlocksOfNeighborChange(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         TilePos queryPos = new TilePos();
-        this.notifyBlockOfNeighborChange(tilePos.add(Direction.WEST, queryPos), id);
-        this.notifyBlockOfNeighborChange(tilePos.add(Direction.EAST, queryPos), id);
-        this.notifyBlockOfNeighborChange(tilePos.add(Direction.DOWN, queryPos), id);
-        this.notifyBlockOfNeighborChange(tilePos.add(Direction.UP, queryPos), id);
-        this.notifyBlockOfNeighborChange(tilePos.add(Direction.NORTH, queryPos), id);
-        this.notifyBlockOfNeighborChange(tilePos.add(Direction.SOUTH, queryPos), id);
+        this.notifyBlockOfNeighborChange(tilePos.add(Direction.WEST, queryPos), block);
+        this.notifyBlockOfNeighborChange(tilePos.add(Direction.EAST, queryPos), block);
+        this.notifyBlockOfNeighborChange(tilePos.add(Direction.DOWN, queryPos), block);
+        this.notifyBlockOfNeighborChange(tilePos.add(Direction.UP, queryPos), block);
+        this.notifyBlockOfNeighborChange(tilePos.add(Direction.NORTH, queryPos), block);
+        this.notifyBlockOfNeighborChange(tilePos.add(Direction.SOUTH, queryPos), block);
     }
 
     @Deprecated
     public final void notifyBlocksOfNeighborChange(final int x, final int y, final int z, final int id) {
-        this.notifyBlocksOfNeighborChange(new TilePos(x, y, z), id);
+        this.notifyBlocksOfNeighborChange(new TilePos(x, y, z), Objects.requireNonNull(Blocks.getBlock(id)));
     }
 
-    private void notifyBlockOfNeighborChange(final @NotNull TilePosc tilePos, final int id) {
+    private void notifyBlockOfNeighborChange(final @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
         if (this.noNeighborUpdate || this.isClientSide) {
             return;
         }
-        final @Nullable Block<?> block = this.getBlock(tilePos);
-        if (block != null) {
-            block.onNeighborChanged(this, tilePos, id);
-        }
+
+        this.getBlockType(tilePos).onNeighborChanged(this, tilePos, block);
     }
 
     public boolean canBlockSeeSky(final @NotNull TilePosc tilePos) {
@@ -990,13 +980,15 @@ public class World implements MutableWorldSource {
         Vector3d end2 = new Vector3d(end);
         TilePos blockEnd = new TilePos(end2);
         TilePos blockStart = new TilePos(start2);
-        int id = getBlockId(blockStart);
+        final @NotNull Block<?> block = getBlockType(blockStart);
         int meta = getBlockData(blockStart);
-        Block<?> block = Blocks.blocksList[id];
-        if (
-            (!ignoreNonColliderBlocks ||
-                (block == null) ||
-                ((useSelectorBoxes ? block.getSelectionAABB(this, blockStart) : block.getCollisionAABB(this, blockStart)) != null)) && (id > 0) && (block != null && block.canCollideCheck(meta, shouldCollideWithFluids))) {
+        final @Nullable AABBdc aabb;
+        if (useSelectorBoxes) {
+            aabb = block.getSelectionAABB(this, blockStart);
+        } else {
+            aabb = block.getCollisionAABB(this, blockStart);
+        }
+        if ((!ignoreNonColliderBlocks || aabb != null) && block.canCollideCheck(meta, shouldCollideWithFluids)) {
             HitResult hitResult = block.collisionRayTrace(this, blockStart, start2, end2, useSelectorBoxes);
             if (hitResult != null) {
                 return hitResult;
@@ -1096,10 +1088,15 @@ public class World implements MutableWorldSource {
                 blockStart.z--;
                 startCopy.z++;
             }
-            Block<?> block1 = getBlock(blockStart);
+            final @NotNull Block<?> block1 = getBlockType(blockStart);
+            final @Nullable AABBdc aabb1;
+            if (useSelectorBoxes) {
+                aabb1 = block1.getSelectionAABB(this, blockStart);
+            } else {
+                aabb1 = block1.getCollisionAABB(this, blockStart);
+            }
             int metadata1 = getBlockData(blockStart);
-            if (
-                (!ignoreNonColliderBlocks || (block1 == null) || ((useSelectorBoxes ? block1.getSelectionAABB(this, blockStart) : block1.getCollisionAABB(this, blockStart)) != null)) && (block1 != null) && block1.canCollideCheck(metadata1, shouldCollideWithFluids)) {
+            if ((!ignoreNonColliderBlocks || aabb1 != null) && block1.canCollideCheck(metadata1, shouldCollideWithFluids)) {
                 HitResult hitResult = block1.collisionRayTrace(this, blockStart, start2, end2, useSelectorBoxes);
                 if (hitResult != null) {
                     return hitResult;
@@ -1124,9 +1121,7 @@ public class World implements MutableWorldSource {
         }
     }
 
-    public void playBlockSoundEffect(@Nullable Entity player, double x, double y, double z, Block<?> block, EnumBlockSoundEffectType soundType) {
-        if (block == null) return;
-
+    public void playBlockSoundEffect(@Nullable Entity player, double x, double y, double z, final @NotNull Block<?> block, EnumBlockSoundEffectType soundType) {
         BlockSound sound = block.getSound();
         if (sound == null) return;
 
@@ -1281,7 +1276,7 @@ public class World implements MutableWorldSource {
         for (d.x = minX - 1; d.x <= maxX; d.x++) {
             for (d.z = minZ - 1; d.z <= maxZ; d.z++) {
                 for (d.y = minY - 1; d.y <= maxY; d.y++) {
-                    Block<?> block = getBlock(d);
+                    Block<?> block = getBlockType(d);
                     if (block != null) {
                         int metadata = getBlockData(d);
                         if (block.collidesWithEntity(entity, this, d) && entity.collidesWithBlock(block, metadata)) {
@@ -1319,7 +1314,7 @@ public class World implements MutableWorldSource {
                     continue;
                 }
                 for (tilePos.y = minY - 1; tilePos.y <= maxY; tilePos.y++) {
-                    Block<?> block = getBlock(tilePos);
+                    Block<?> block = getBlockType(tilePos);
                     if (block != null && block.isSolidRender()) {
                         // ignore mesh blocks if entity is instance of an item
                         if (!(entity instanceof EntityItem && (block.id() == Blocks.MESH.id() || block.id() == Blocks.SPIKES.id() || block.id() == Blocks.MOBSPAWNER.id())))
@@ -1421,17 +1416,17 @@ public class World implements MutableWorldSource {
 
     @Deprecated
     public final void scheduleBlockUpdate(final int x, final int y, final int z, final int id, final long delay) {
-        this.scheduleBlockUpdate(new TilePos(x, y, z), id, delay);
+        this.scheduleBlockUpdate(new TilePos(x, y, z), Objects.requireNonNull(Blocks.getBlock(id)), delay);
     }
 
-    public void scheduleBlockUpdate(final @NotNull TilePosc tilePos, final int id, final long delay) {
-        NextTickListEntry entry = new NextTickListEntry(tilePos, id);
+    public void scheduleBlockUpdate(final @NotNull TilePosc tilePos, final @NotNull Block<?> block, final long delay) {
+        NextTickListEntry entry = new NextTickListEntry(tilePos, block);
         final byte radius = 8;
 
         if (this.scheduledUpdatesAreImmediate && !this.immediatelyUpdatedPositions.contains(entry)) {
             if (areBlocksLoaded(entry.tilePos.x - radius, entry.tilePos.y - radius, entry.tilePos.z - radius, entry.tilePos.x() + radius, entry.tilePos.y() + radius, entry.tilePos.z() + radius)) {
-                final @NotNull Block<?> block = this.getBlock(entry.tilePos);
-                if (block != null && block.id() == entry.blockId) {
+                final @NotNull Block<?> worldBlock = this.getBlockType(entry.tilePos);
+                if (worldBlock == entry.block) {
                     this.immediatelyUpdatedPositions.add(entry);
                     block.updateTick(this, entry.tilePos, this.rand, false);
                 }
@@ -1439,9 +1434,7 @@ public class World implements MutableWorldSource {
             return;
         }
         if (areBlocksLoaded(tilePos, radius)) {
-            if (id > 0) {
-                entry.setDelay(delay + runtime);
-            }
+            entry.setDelay(delay + runtime);
             if (!this.tickNextTickSet.contains(entry)) {
                 this.tickNextTickSet.add(entry);
                 this.tickNextTickList.add(entry);
@@ -1641,9 +1634,11 @@ public class World implements MutableWorldSource {
         for (tilePos.x = minX; tilePos.x <= maxX; tilePos.x++) {
             for (tilePos.y = minY; tilePos.y <= maxY; tilePos.y++) {
                 for (tilePos.z = minZ; tilePos.z <= maxZ; tilePos.z++) {
-                    Block<?> block = getBlock(tilePos);
-                    if (block != null && block.getMaterial().isLiquid()) {
-                        return true;
+                    if (isBlockLoaded(tilePos)) {
+                        Block<?> block = getBlockType(tilePos);
+                        if (block != null && block.getMaterial().isLiquid()) {
+                            return true;
+                        }
                     }
                 }
             }
@@ -1672,8 +1667,8 @@ public class World implements MutableWorldSource {
         for (tilePos.x = minX; tilePos.x < maxX; tilePos.x++) {
             for (tilePos.y = minY; tilePos.y < maxY; tilePos.y++) {
                 for (tilePos.z = minZ; tilePos.z < maxZ; tilePos.z++) {
-                    Block<?> block = getBlock(tilePos);
-                    if (block == null || !isMaterialInBB(aabb, material)) {
+                    final @NotNull Block<?> block = getBlockType(tilePos);
+                    if (!isMaterialInBB(aabb, material)) {
                         continue;
                     }
                     flag = true;
@@ -1705,7 +1700,7 @@ public class World implements MutableWorldSource {
         for (tilePos.x = minX_i; tilePos.x < maxX_i; tilePos.x++) {
             for (tilePos.y = minY_i; tilePos.y < maxY_i; tilePos.y++) {
                 for (tilePos.z = minZ_i; tilePos.z < maxZ_i; tilePos.z++) {
-                    Block<?> block = getBlock(tilePos);
+                    Block<?> block = getBlockType(tilePos);
                     if (block != null) {
                         boolean isMaterial = false;
                         for (Material m : materials) {
@@ -1739,7 +1734,7 @@ public class World implements MutableWorldSource {
         for (tilePos.x = minX_i; tilePos.x < maxX_i; tilePos.x++) {
             for (tilePos.y = minY_i; tilePos.y < maxY_i; tilePos.y++) {
                 for (tilePos.z = minZ_i; tilePos.z < maxZ_i; tilePos.z++) {
-                    Block<?> block = getBlock(tilePos);
+                    Block<?> block = getBlockType(tilePos);
                     if (block != null) {
                         if (block.getMaterial() != material) continue;
 
@@ -1765,8 +1760,8 @@ public class World implements MutableWorldSource {
         for (tilePos.x = minX; tilePos.x < maxX; tilePos.x++) {
             for (tilePos.y = minY; tilePos.y < maxY; tilePos.y++) {
                 for (tilePos.z = minZ; tilePos.z < maxZ; tilePos.z++) {
-                    Block<?> block = getBlock(tilePos);
-                    if (block == null || block.getMaterial() != material) {
+                    final @NotNull Block<?> block = getBlockType(tilePos);
+                    if (block.getMaterial() != material) {
                         continue;
                     }
                     int j2 = getBlockData(tilePos);
@@ -1828,13 +1823,13 @@ public class World implements MutableWorldSource {
         return (float) i / (float) j;
     }
 
-    public void onBlockHit(final @NotNull Player player, final @NotNull TilePos tilePos, final @NotNull Side side) {
+    public void onBlockHit(final @NotNull Player player, final @NotNull TilePosc tilePos, final @NotNull Side side) {
         final @NotNull TilePos offsetPos = tilePos.add(side.getDirection(), new TilePos());
-        final @Nullable Block<?> block = this.getBlock(offsetPos);
+        final @Nullable Block<?> block = this.getBlockType(offsetPos);
 
         if (block == Blocks.FIRE || block == Blocks.FIRE_COLD) {
             this.playBlockEvent(player, offsetPos, LevelListener.EVENT_FIRE_EXTINGUISH, 0);
-            this.setBlockIdNotify(tilePos, 0);
+            this.setBlockTypeNotify(tilePos, Blocks.AIR);
         }
     }
 
@@ -1894,12 +1889,12 @@ public class World implements MutableWorldSource {
 
     @Override
     public boolean isBlockOpaqueCube(final @NotNull TilePosc tilePos) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
+        final @Nullable Block<?> block = this.getBlockType(tilePos);
         return block != null && block.isSolidRender();
     }
 
     public boolean canPlaceOnSurfaceOfBlock(final @NotNull TilePos tilePos) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
+        final @Nullable Block<?> block = this.getBlockType(tilePos);
         return block != null && block.canPlaceOnSurfaceOnCondition(this, tilePos.x, tilePos.y, tilePos.z);
     }
 
@@ -1909,12 +1904,7 @@ public class World implements MutableWorldSource {
     }
 
     public @NotNull ISupport getSupport(final @NotNull TilePos tilePos, final @NotNull Side side) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
-        if (block == null) {
-            return PartialSupport.INSTANCE;
-        }
-
-        return block.getSupport(this, tilePos.x, tilePos.y, tilePos.z, side);
+        return this.getBlockType(tilePos).getSupport(this, tilePos, side);
     }
 
     @Deprecated
@@ -1925,13 +1915,12 @@ public class World implements MutableWorldSource {
     @Override
     public boolean isBlockNormalCube(final @NotNull TilePosc tilePos) {
         // Determines if you suffocate in a block, among other things.
-        final @Nullable Block<?> block = this.getBlock(tilePos);
-        return block != null && block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos);
+        final @NotNull Block<?> block = this.getBlockType(tilePos);
+        return block.getMaterial().isSolidBlocking() && block.renderAsNormalBlockOnCondition(this, tilePos);
     }
 
     public boolean canPlaceInsideBlock(final @NotNull TilePosc tilePos) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
-        return block == null || block.hasTag(BlockTags.PLACE_OVERWRITES);
+        return this.getBlockType(tilePos).hasTag(BlockTags.PLACE_OVERWRITES);
     }
 
     @Deprecated
@@ -2172,8 +2161,8 @@ public class World implements MutableWorldSource {
             if (!this.areBlocksLoaded(entry.tilePos.x - radius, entry.tilePos.y - radius, entry.tilePos.z - radius, entry.tilePos.x + radius, entry.tilePos.y + radius, entry.tilePos.z + radius)) {
                 continue;
             }
-            final @Nullable Block<?> block = this.getBlock(entry.tilePos);
-            if (block != null && block.id() == entry.blockId) {
+            final @Nullable Block<?> block = this.getBlockType(entry.tilePos);
+            if (block == entry.block) {
                 block.updateTick(this, entry.tilePos, this.rand, false);
             }
         }
@@ -2193,7 +2182,7 @@ public class World implements MutableWorldSource {
                 this.rand.nextInt(radius) - this.rand.nextInt(radius),
                 randomPos);
 
-            final @Nullable Block<?> block = this.getBlock(randomPos);
+            final @Nullable Block<?> block = this.getBlockType(randomPos);
             if (block != null) {
                 block.animationTick(this, randomPos, random);
             }
@@ -2298,11 +2287,8 @@ public class World implements MutableWorldSource {
             return false;
         }
 
-        final @Nullable Block<?> currentBlock = this.getBlock(tilePos);
-        final @Nullable Block<?> newBlock = Blocks.blocksList[id];
-        if (newBlock == null) {
-            return false;
-        }
+        final @NotNull Block<?> currentBlock = this.getBlockType(tilePos);
+        final @NotNull Block<?> newBlock = Objects.requireNonNull(Blocks.blocksList[id]);
 
         final @Nullable AABBdc bb;
         if (ignoreCollision) {
@@ -2315,7 +2301,7 @@ public class World implements MutableWorldSource {
             return false;
         }
 
-        if (currentBlock == null || currentBlock.hasTag(BlockTags.PLACE_OVERWRITES)) {
+        if (currentBlock.hasTag(BlockTags.PLACE_OVERWRITES)) {
             return newBlock.canPlaceOnSide(this, tilePos, side);
         } else {
             return false;
@@ -2359,7 +2345,7 @@ public class World implements MutableWorldSource {
     }
 
     public boolean hasDirectSignal(final @NotNull TilePosc tilePos, final @NotNull Side side) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
+        final @Nullable Block<?> block = this.getBlockType(tilePos);
         return block != null && block.isEmittingDirectSignal(this, tilePos, side);
     }
 
@@ -2385,13 +2371,10 @@ public class World implements MutableWorldSource {
     }
 
     public boolean hasSignal(final @NotNull TilePosc tilePos, final @NotNull Side side) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
+        final @NotNull Block<?> block = this.getBlockType(tilePos);
         if (this.isBlockNormalCube(tilePos) && block != Blocks.BLOCK_REDSTONE && block != Blocks.PUMPKIN_REDSTONE && block != Blocks.MATCHER_ACTIVE) {
             return this.hasDirectSignal(tilePos);
         }
-        if (block == null) {
-            return false;
-        }
 
         if (block == Blocks.PUMPKIN_REDSTONE) {
             return this.pumpkinHasDirectSignal(tilePos) || block.isEmittingSignal(this, tilePos, side);
@@ -2696,7 +2679,7 @@ public class World implements MutableWorldSource {
     }
 
     public void triggerEvent(final @NotNull TilePosc tilePos, final int index, final int data) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
+        final @Nullable Block<?> block = this.getBlockType(tilePos);
         if (block != null) {
             block.triggerEvent(this, tilePos.x(), tilePos.y(), tilePos.z(), index, data);
         }
diff --git a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
index 3294d86ed..21aadb3ef 100644
--- a/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
+++ b/game/core/src/main/java/net/minecraft/core/world/WorldSource.java
@@ -15,18 +15,16 @@ import org.jetbrains.annotations.Nullable;
 public interface WorldSource {
     int getHeightBlocks();
 
-    int getBlockId(final @NotNull TilePosc tilePos);
-
     @Deprecated
     default int getBlockId(final int x, final int y, final int z) {
-        return this.getBlockId(new TilePos(x, y, z));
+        return this.getBlockType(new TilePos(x, y, z)).id();
     }
 
-    @Nullable Block<?> getBlock(final @NotNull TilePosc tilePos);
+    @NotNull Block<?> getBlockType(final @NotNull TilePosc tilePos);
 
     @Deprecated
-    default @Nullable Block<?> getBlock(final int x, final int y, final int z) {
-        return this.getBlock(new TilePos(x, y, z));
+    default @NotNull Block<?> getBlock(final int x, final int y, final int z) {
+        return this.getBlockType(new TilePos(x, y, z));
     }
 
     @Nullable TileEntity getTileEntity(final @NotNull TilePosc tilePos);
@@ -37,11 +35,7 @@ public interface WorldSource {
     }
 
     default <T> @Nullable T getBlockLogic(final @NotNull TilePosc tilePos, final @NotNull Class<T> logicClass) {
-        final @Nullable Block<?> block = this.getBlock(tilePos);
-        if (block == null) {
-            return null;
-        }
-
+        final @NotNull Block<?> block = this.getBlockType(tilePos);
         final @NotNull BlockLogic logic = block.getLogic();
         if (logicClass.isAssignableFrom(logic.getClass())) {
             return logicClass.cast(logic);
